use mail_app::startup::run;
use mail_app::configuration::get_configuration;
use std::net::TcpListener;
use sqlx::PgPool;

#[actix_web::main]
async fn main() -> std::io::Result<()> {
    // Attempt to read from config
    let configuration = get_configuration().expect("Failed to read configuration data.");

    // Configure connection to database for our startup
    let connection_pool = PgPool::connect(&configuration.database.connection_string())
        .await
        .expect("Failed to connect to Postgres.");

    // Take port from settings file
    let address = format!("127.0.0.1:{}", configuration.application_port);
    let listener = TcpListener::bind(address)?;
    run(listener, connection_pool)?.await
}